//
//  uart.c
//
//  Created by Michael Köhler on 20.10.15.
//

#include "uart.h"


void uartSetup(uint16_t baudRate){
	uint16_t ubrrValue = (F_CPU+baudRate*8UL)/(baudRate*16UL)-1UL;
    //set Baudrate
    UBRR0H = ubrrValue >> 8;
    UBRR0L = ubrrValue & 0xFF;
    //set other UART Settings
    UCSR0B |= (1<<TXEN0)|(1 << RXEN0);  // UART TX/RX einschalten
}
void sendChar(unsigned char zeichen){
    {
        /* Wait for empty transmit buffer */
        while ( !( UCSR0A & (1<<UDRE0)) );
        /* Put data into buffer, sends the data */
        UDR0 = zeichen;
    }
}
void sendString(const char* charOfString){
    //send string from ram
    /* while *charOfString != '\0' */
    while (*charOfString) {
        sendChar(*charOfString);
        charOfString++;
    }
}
void sendString_p(const char* charOfString){
    //send string from flash
    register char c;
    /* while *charOfString != '\0 */
    while ( (c = pgm_read_byte(charOfString++)) ) {
        sendChar(c);
    }
}

void sendString_e(const char* charOfString){
    //send string from eeprom
    register char c;
    /* while *charOfString != '\0 */
    while ( (c = eeprom_read_byte((uint8_t*)charOfString++)) ) {
        sendChar(c);
    }
}