//
//  uart.h
//
//  Created by Michael Köhler on 20.10.15.
//
//

#ifndef uart_h
#define uart_h

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>

#define commandComplete         '\n'
#define BAUDRATE                38400UL

#define UART_MAXSTRLEN          40

#define UBRR_VAL (F_CPU+BAUDRATE*8)/(BAUDRATE*16)-1     // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))             // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUDRATE)          // Fehler in Promille, 1000 = kein Fehler.

#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
#error Systematischer Fehler der Baudrate grösser 1% und damit zu hoch!
#endif

void uartSetup(uint16_t baudRate);
void sendChar(unsigned char zeichen);
void sendString(const char* charOfString);
void sendString_p(const char* charOfString);
void sendString_e(const char* charOfString);

#endif /* uart_h */
